## tcl8.4 8.4.12

=== macosx/Makefile ===
########################################################################################################
#
# Makefile wrapper to build tcl on Mac OS X in a way compatible with the tk/macosx Xcode buildsystem
#	uses the standard unix build system in tcl/unix (which can be used directly instead of this
#	if you are not using the tk/macosx projects).
#
# RCS: @(#) $Id: Makefile,v 1.5.2.14 2005/11/27 02:34:41 das Exp $
#
########################################################################################################

#-------------------------------------------------------------------------------------------------------
# customizable settings

DESTDIR			?=
INSTALL_ROOT		?= ${DESTDIR}

BUILD_DIR		?= ${CURDIR}/../../build
SYMROOT			?= ${BUILD_DIR}/${PROJECT}
OBJROOT			?= ${SYMROOT}

EXTRA_CONFIGURE_ARGS 	?= 
EXTRA_MAKE_ARGS		?= 

INSTALL_PATH		?= /Library/Frameworks
PREFIX			?= /usr/local
BINDIR			?= ${PREFIX}/bin
LIBDIR			?= ${INSTALL_PATH}
MANDIR			?= ${PREFIX}/man

# set to non-empty value to install manpages in addition to html help:
INSTALL_MANPAGES 	?= 

#-------------------------------------------------------------------------------------------------------
# meta targets

meta 			:= all install embedded install-embedded clean distclean test

styles			:= develop deploy

all			:= ${styles}
all			: ${all}

install			:= ${styles:%=install-%}
install			: ${install}
install-%:		action := install-

embedded		:= ${styles:%=embedded-%}
embedded		: embedded-deploy
install-embedded	:= ${embedded:%=install-%}
install-embedded	: install-embedded-deploy

clean			:= ${styles:%=clean-%}
clean			: ${clean}
clean-%:		action := clean-
distclean		:= ${styles:%=distclean-%}
distclean		: ${distclean}
distclean-%:		action := distclean-

test			:= ${styles:%=test-%}
test			: ${test}
test-%:			action := test-

targets			:= $(foreach v,${meta},${$v})

#-------------------------------------------------------------------------------------------------------
# build styles

BUILD_STYLE		=
CONFIGURE_ARGS		=
OBJ_DIR			= ${OBJROOT}/${BUILD_STYLE}

develop_make_args	:= BUILD_STYLE=Development CONFIGURE_ARGS=--enable-symbols
deploy_make_args	:= BUILD_STYLE=Deployment INSTALL_TARGET=install-strip \
			   GENERIC_FLAGS=-DNDEBUG
embedded_make_args	:= EMBEDDED_BUILD=1
install_make_args	:= INSTALL_BUILD=1

${targets}: 
	${MAKE} ${action}${PROJECT} \
	$(foreach s,${styles} embedded install,$(if $(findstring $s,$@),${${s}_make_args}))

#-------------------------------------------------------------------------------------------------------
# project specific settings

PROJECT			:= tcl
PRODUCT_NAME		:= Tcl

UNIX_DIR		:= ${CURDIR}/../unix
VERSION			:= $(shell awk -F= '/^TCL_VERSION/ {print $$2; nextfile}' ${UNIX_DIR}/configure.in)
TCLSH			:= tclsh${VERSION}

BUILD_TARGET		:= all tcltest
INSTALL_TARGET		:= install

export CPPROG		:= cp -p

INSTALL_TARGETS		= install-binaries install-libraries
ifeq (${EMBEDDED_BUILD},)
INSTALL_TARGETS		+= install-private-headers
endif
ifeq (${INSTALL_BUILD}_${EMBEDDED_BUILD}_${BUILD_STYLE},1__Deployment)
INSTALL_TARGETS		+= html-tcl
ifneq (${INSTALL_MANPAGES},)
INSTALL_TARGETS		+= install-doc
endif
endif

MAKE_VARS		:= INSTALL_ROOT INSTALL_TARGETS VERSION GENERIC_FLAGS
MAKE_ARGS_V		= $(foreach v,${MAKE_VARS},$v='${$v}')

build-${PROJECT}:	target = ${BUILD_TARGET}
install-${PROJECT}:	target = ${INSTALL_TARGET}
clean-${PROJECT} distclean-${PROJECT} test-${PROJECT}: \
			target = $*

DO_MAKE			= +${MAKE} -C ${OBJ_DIR} ${target} ${MAKE_ARGS_V} ${MAKE_ARGS} ${EXTRA_MAKE_ARGS}

#-------------------------------------------------------------------------------------------------------
# build rules

${PROJECT}:
	${MAKE} install-${PROJECT} INSTALL_ROOT=${OBJ_DIR}/

${OBJ_DIR}/Makefile: ${UNIX_DIR}/Makefile.in ${UNIX_DIR}/configure \
                     ${UNIX_DIR}/tclConfig.sh.in Tcl-Info.plist.in
	mkdir -p ${OBJ_DIR} && cd ${OBJ_DIR} && \
	if [ ${UNIX_DIR}/configure -nt config.status ]; then ${UNIX_DIR}/configure \
	--prefix=${PREFIX} --bindir=${BINDIR} --libdir=${LIBDIR} \
	--mandir=${MANDIR} --enable-threads --enable-framework \
	${CONFIGURE_ARGS} ${EXTRA_CONFIGURE_ARGS}; else ./config.status; fi

build-${PROJECT}: ${OBJ_DIR}/Makefile
	${DO_MAKE}
# symolic link hackery to trick
# 'make install INSTALL_ROOT=${OBJ_DIR}'
# into building Tcl.framework and tclsh in ${SYMROOT}
	@cd ${OBJ_DIR} && mkdir -p $(dir ./${LIBDIR}) $(dir ./${BINDIR}) ${SYMROOT} && \
	rm -f ./${LIBDIR} ./${BINDIR} && ln -fs ${SYMROOT} ./${LIBDIR} && \
	ln -fs ${SYMROOT} ./${BINDIR} && ln -fs ${OBJ_DIR}/tcltest ${SYMROOT}

install-${PROJECT}: build-${PROJECT}
ifeq (${EMBEDDED_BUILD}_${INSTALL_ROOT},1_)
	@echo "Cannot install-embedded with empty INSTALL_ROOT !" && false
endif
ifeq (${EMBEDDED_BUILD},1)
	@rm -rf "${INSTALL_ROOT}/${LIBDIR}/Tcl.framework"
endif
	${DO_MAKE}
ifeq (${INSTALL_BUILD},1)
ifeq (${EMBEDDED_BUILD},1)
# if we are embedding frameworks, don't install tclsh
	@rm -f "${INSTALL_ROOT}${BINDIR}/${TCLSH}" && \
	rmdir -p "${INSTALL_ROOT}${BINDIR}" 2>&- || true
else
# redo prebinding
	@cd ${INSTALL_ROOT}/ && \
	if [ ! -d usr/lib ]; then mkdir -p usr && ln -fs /usr/lib usr/ && RM_USRLIB=1; fi; \
	if [ ! -d System ]; then ln -fs /System . && RM_SYSTEM=1; fi; \
	redo_prebinding -r . "./${LIBDIR}/${PRODUCT_NAME}.framework/Versions/${VERSION}/${PRODUCT_NAME}"; \
	redo_prebinding -r . "./${BINDIR}/${TCLSH}"; \
	if [ -n "$${RM_USRLIB:-}" ]; then rm -f usr/lib; rmdir -p usr 2>&-; fi; \
	if [ -n "$${RM_SYSTEM:-}" ]; then rm -f System; fi
# install tclsh symbolic link
	@ln -fs ${TCLSH} ${INSTALL_ROOT}${BINDIR}/tclsh
endif
endif
ifeq (${BUILD_STYLE}_${EMBEDDED_BUILD},Development_)
# keep copy of debug library around, so that
# Deployment build can be installed on top
# of Development build without overwriting
# the debug library
	@cd ${INSTALL_ROOT}${LIBDIR}/${PRODUCT_NAME}.framework/Versions/${VERSION} && \
	ln -f "${PRODUCT_NAME}" "${PRODUCT_NAME}_debug"
endif

clean-${PROJECT}: %-${PROJECT}:
	${DO_MAKE}
	rm -rf ${SYMROOT}/{${PRODUCT_NAME}.framework,${TCLSH},tcltest}
	rm -f ${OBJ_DIR}{${LIBDIR},${BINDIR}} && \
	rmdir -p ${OBJ_DIR}$(dir ${LIBDIR}) 2>&- || true && \
	rmdir -p ${OBJ_DIR}$(dir ${BINDIR}) 2>&- || true

distclean-${PROJECT}: %-${PROJECT}: clean-${PROJECT}
	${DO_MAKE}
	rm -rf ${OBJ_DIR}
	
test-${PROJECT}: %-${PROJECT}: build-${PROJECT}
	${DO_MAKE}

#-------------------------------------------------------------------------------------------------------

.PHONY: ${meta} ${targets} ${PROJECT} build-${PROJECT} install-${PROJECT} \
	clean-${PROJECT} distclean-${PROJECT}

.NOTPARALLEL:

#-------------------------------------------------------------------------------------------------------

## tcl8.4 8.4.14

=== macosx/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #	uses the standard unix build system in tcl/unix (which can be used directly instead of this
 #	if you are not using the tk/macosx projects).
 #
-# RCS: @(#) $Id: Makefile,v 1.5.2.14 2005/11/27 02:34:41 das Exp $
+# RCS: @(#) $Id: Makefile,v 1.5.2.16 2006/10/16 17:34:42 das Exp $
 #
 ########################################################################################################
 
@@ -131,12 +131,14 @@
 
 build-${PROJECT}: ${OBJ_DIR}/Makefile
 	${DO_MAKE}
+ifeq (${INSTALL_BUILD},)
 # symolic link hackery to trick
 # 'make install INSTALL_ROOT=${OBJ_DIR}'
 # into building Tcl.framework and tclsh in ${SYMROOT}
 	@cd ${OBJ_DIR} && mkdir -p $(dir ./${LIBDIR}) $(dir ./${BINDIR}) ${SYMROOT} && \
 	rm -f ./${LIBDIR} ./${BINDIR} && ln -fs ${SYMROOT} ./${LIBDIR} && \
 	ln -fs ${SYMROOT} ./${BINDIR} && ln -fs ${OBJ_DIR}/tcltest ${SYMROOT}
+endif
 
 install-${PROJECT}: build-${PROJECT}
 ifeq (${EMBEDDED_BUILD}_${INSTALL_ROOT},1_)
@@ -152,14 +154,17 @@
 	@rm -f "${INSTALL_ROOT}${BINDIR}/${TCLSH}" && \
 	rmdir -p "${INSTALL_ROOT}${BINDIR}" 2>&- || true
 else
-# redo prebinding
-	@cd ${INSTALL_ROOT}/ && \
+# redo prebinding (when not building for Mac OS X 10.4 or later only)
+	@if [ "`echo "$${MACOSX_DEPLOYMENT_TARGET}" | \
+	awk -F '10\\.' '{print int($$2)}'`" -lt 4 -a "`echo "$${CFLAGS}" | \
+	awk -F '-mmacosx-version-min=10\\.' '{print int($$2)}'`" -lt 4 ]; \
+	then cd ${INSTALL_ROOT}/; \
 	if [ ! -d usr/lib ]; then mkdir -p usr && ln -fs /usr/lib usr/ && RM_USRLIB=1; fi; \
 	if [ ! -d System ]; then ln -fs /System . && RM_SYSTEM=1; fi; \
 	redo_prebinding -r . "./${LIBDIR}/${PRODUCT_NAME}.framework/Versions/${VERSION}/${PRODUCT_NAME}"; \
 	redo_prebinding -r . "./${BINDIR}/${TCLSH}"; \
 	if [ -n "$${RM_USRLIB:-}" ]; then rm -f usr/lib; rmdir -p usr 2>&-; fi; \
-	if [ -n "$${RM_SYSTEM:-}" ]; then rm -f System; fi
+	if [ -n "$${RM_SYSTEM:-}" ]; then rm -f System; fi; fi
 # install tclsh symbolic link
 	@ln -fs ${TCLSH} ${INSTALL_ROOT}${BINDIR}/tclsh
 endif

## tcl8.4 8.4.19

=== macosx/Makefile ===
--- 
+++ 
@@ -4,7 +4,12 @@
 #	uses the standard unix build system in tcl/unix (which can be used directly instead of this
 #	if you are not using the tk/macosx projects).
 #
-# RCS: @(#) $Id: Makefile,v 1.5.2.16 2006/10/16 17:34:42 das Exp $
+# Copyright (c) 2002-2007 Daniel A. Steffen <das@users.sourceforge.net>
+#
+# See the file "license.terms" for information on usage and redistribution of
+# this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#
+# RCS: @(#) $Id: Makefile,v 1.5.2.18 2007/09/13 15:28:17 das Exp $
 #
 ########################################################################################################
 
@@ -18,8 +23,8 @@
 SYMROOT			?= ${BUILD_DIR}/${PROJECT}
 OBJROOT			?= ${SYMROOT}
 
-EXTRA_CONFIGURE_ARGS 	?= 
-EXTRA_MAKE_ARGS		?= 
+EXTRA_CONFIGURE_ARGS	?=
+EXTRA_MAKE_ARGS		?=
 
 INSTALL_PATH		?= /Library/Frameworks
 PREFIX			?= /usr/local
@@ -28,12 +33,12 @@
 MANDIR			?= ${PREFIX}/man
 
 # set to non-empty value to install manpages in addition to html help:
-INSTALL_MANPAGES 	?= 
+INSTALL_MANPAGES	?=
 
 #-------------------------------------------------------------------------------------------------------
 # meta targets
 
-meta 			:= all install embedded install-embedded clean distclean test
+meta			:= all install embedded install-embedded clean distclean test
 
 styles			:= develop deploy
 
@@ -75,7 +80,7 @@
 embedded_make_args	:= EMBEDDED_BUILD=1
 install_make_args	:= INSTALL_BUILD=1
 
-${targets}: 
+${targets}:
 	${MAKE} ${action}${PROJECT} \
 	$(foreach s,${styles} embedded install,$(if $(findstring $s,$@),${${s}_make_args}))
 
@@ -122,11 +127,11 @@
 	${MAKE} install-${PROJECT} INSTALL_ROOT=${OBJ_DIR}/
 
 ${OBJ_DIR}/Makefile: ${UNIX_DIR}/Makefile.in ${UNIX_DIR}/configure \
-                     ${UNIX_DIR}/tclConfig.sh.in Tcl-Info.plist.in
+		     ${UNIX_DIR}/tclConfig.sh.in Tcl-Info.plist.in
 	mkdir -p ${OBJ_DIR} && cd ${OBJ_DIR} && \
 	if [ ${UNIX_DIR}/configure -nt config.status ]; then ${UNIX_DIR}/configure \
 	--prefix=${PREFIX} --bindir=${BINDIR} --libdir=${LIBDIR} \
-	--mandir=${MANDIR} --enable-threads --enable-framework \
+	--mandir=${MANDIR} --enable-threads --enable-framework --enable-dtrace \
 	${CONFIGURE_ARGS} ${EXTRA_CONFIGURE_ARGS}; else ./config.status; fi
 
 build-${PROJECT}: ${OBJ_DIR}/Makefile
@@ -188,7 +193,7 @@
 distclean-${PROJECT}: %-${PROJECT}: clean-${PROJECT}
 	${DO_MAKE}
 	rm -rf ${OBJ_DIR}
-	
+
 test-${PROJECT}: %-${PROJECT}: build-${PROJECT}
 	${DO_MAKE}

=== debian/changelog ===
tcl8.4 (8.4.19-5ubuntu1) raring; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Pacify _FORTIFY_SOURCE.
    - Support cross-building.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 28 Nov 2012 00:27:57 +0000

tcl8.4 (8.4.19-5) unstable; urgency=low

  * Moved /usr/share/tcltk/tcl8.4/tclConfig.sh back to the /usr/lib/tcl8.4
    directory because it is architecture dependent.
  * Removed Chris Waters wrom the uploaders list (closes: #664111).
  * Renamed suggested dependency to tcl-tclreadline.
  * Added ${misc:Depends} substitution variable to debian/control because the
    package uses debhelper.
  * Switched to 3.0 (quilt) source package format.
  * Bumped debhelper compatibility version to 8.
  * Added hardening build flags using dpkg-buildflags.
  * Bumped standards version to 3.9.3.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 28 May 2012 16:31:52 +0400

tcl8.4 (8.4.19-4ubuntu4) quantal; urgency=low

  * Rebuild for new armel compiler default of ARMv5t.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 09 Oct 2012 02:08:22 +0100

tcl8.4 (8.4.19-4ubuntu3) natty; urgency=low

  * Pass CC to compiler and set ac_cv variables, to allow cross builds -
    see http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=597708

 -- Peter Pearse <peter.pearse@linaro.org>  Thu, 10 Feb 2011 09:26:48 +0000

tcl8.4 (8.4.19-4ubuntu2) natty; urgency=low

  * Update patch fortify-source to use a cleaner fix from upstream (use memcpy
    instead of strcpy); see SF #3127687; LP: #683546.

 -- Loïc Minier <loic.minier@linaro.org>  Mon, 06 Dec 2010 01:27:25 +0100

tcl8.4 (8.4.19-4ubuntu1) natty; urgency=low

  * New patch, fortify-source, pass -U_FORTIFY_SOURCE when building
    generic/tclCmdMZ.c to workaround a false positive; see LP #683546.

 -- Loïc Minier <loic.minier@linaro.org>  Sun, 05 Dec 2010 00:32:38 +0100

tcl8.4 (8.4.19-4build1) natty; urgency=low

  * No-change upload to drop sizable upstream changelog.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 22 Nov 2010 11:39:44 +0100

tcl8.4 (8.4.19-4) unstable; urgency=low

  * Removed Anselm Lingnau from uploaders list (closes: #540848).
  * Protected quilt calls in debian/rules to make conversion to source
    format 3.0 (quilt) possible (closes: #484913).
  * Added README.source which describes how to work with quilt.
  * Use SourceForge redirector in debian/watch uscan control file.
  * Bumped standards version to 3.8.3.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 05 Sep 2009 11:34:08 +0400

tcl8.4 (8.4.19-3) unstable; urgency=low

  * Don't remove tclsh alternative in case of package upgrade because the
    manually installed alternative is also removed which isn't desirable.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 01 Mar 2009 10:35:09 +0300

tcl8.4 (8.4.19-2) unstable; urgency=low

  * Fixed clean target to work with debhelper 7.0 (made dh_clean the last
    command, so debhelper logs are removed now).

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 01 May 2008 12:13:47 +0400

tcl8.4 (8.4.19-1) unstable; urgency=low

  * New upstream release.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 19 Apr 2008 18:09:51 +0400

tcl8.4 (8.4.18-3) unstable; urgency=low

  * Quoted CFLAGS in debian/rules when passing to the shell, not when
    assigning to a make variable; otherwise the quotes end up as part of
    the variable and many things go wrong, leading to a build failure
    (closes: #467397, #476015).
  * Explicitly specified configure options --host and --build to make build
    results more predictable.
  * Cleaned up debian/rules.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 14 Apr 2008 23:01:19 +0400

tcl8.4 (8.4.18-2) unstable; urgency=low

  * Upload to unstable.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 09 Feb 2008 01:39:26 +0300

tcl8.4 (8.4.18-1) experimental; urgency=low

  * New upstream release.
  * Overridden lintian warning package-name-doesnt-match-sonames since tcl8.4
    package contains not only a library, and it's unreasonable to split it
    into smaller parts.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 08 Feb 2008 21:35:49 +0300

tcl8.4 (8.4.17-1) unstable; urgency=low

  * New upstream release.
  * Bumped standards version to 3.7.3.

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 03 Jan 2008 02:40:34 +0300

tcl8.4 (8.4.16-4) unstable; urgency=medium

  * Temporarily (until transition to a new Tcl/Tk policy is done) readded
    /usr/lib to TCL_PACKAGE_PATH variable (closes: #451129, #451195).

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 14 Nov 2007 08:42:30 +0300

tcl8.4 (8.4.16-3) unstable; urgency=low

  * Fixed tcl8.4-dev.preinst bug in update-alternatives call (ignore return
    value if tcl.m4 alternative doesn't exist already,
    closes: #447310, #447311).

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 20 Oct 2007 06:14:00 +0400

tcl8.4 (8.4.16-2) unstable; urgency=low

  [ Sergei Golovan ]
  * Added -fno-unit-at-a-time option to prevent stack corruption in a
    particular use case (closes: #446335).
  * Added /usr/local/lib/tcltk, /usr/local/share/tcltk, /usr/lib/tcltk,
    /usr/share/tcltk to auto_path variable. These directories are to be
    contain Tcl/Tk packages according to upcoming Debian Tcl/Tk Policy
    (preliminary version see at
    http://pkg-tcltk.alioth.debian.org/tcltk-policy.html/)
  * Removed TCL_INC_DIR from tclConfig.sh and tcl.m4.
  * Moved architecture independent files from /usr/lib/tcl8.4 to
    /usr/share/tcltk/tcl8.4. To keep backward compatibility tclConfig.sh is
    linked to /usr/lib/tcl8.4 directory.
  * Fixed bug with update-alternatives in prerm scripts.
  * Removed conflicts with tcl and providing tcl-dev packages from
    debian/control to prepare binary packages for default tcl and tcl-dev.
  * Removed build-essential package from tcl8.4-dev dependencies.
  * Moved tcl.m4 to /usr/share/aclocal/tcl8.4.m4 to make it easier to use
    different versions of tcl.m4.
  * Removed alternative of tcl.m4 (the link to default tcl.m4 is to be


=== debian/control ===
Source: tcl8.4
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Tcl/Tk Packagers <pkg-tcltk-devel@lists.alioth.debian.org>
Uploaders: Sergei Golovan <sgolovan@debian.org>
Build-Depends: debhelper (>= 8.0.0), dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.3
Homepage: http://www.tcl.tk/

Package: tcl8.4
Section: interpreters
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: tcl74 (<= 7.4p3-2)
Provides: tclsh
Suggests: tcl-tclreadline
Description: Tcl (the Tool Command Language) v8.4 - run-time files
 Tcl is a powerful, easy to use, embeddable, cross-platform interpreted
 scripting language.  This package contains everything you need to run
 Tcl scripts and Tcl-enabled apps.  This version includes thread support.

Package: tcl8.4-doc
Section: doc
Priority: optional
Architecture: all
Depends: ${misc:Depends}
Suggests: tcl8.4
Conflicts: tcldoc, tcl8.3-doc
Provides: tcldoc
Description: Tcl (the Tool Command Language) v8.4 - manual pages
 Tcl is a powerful, easy-to-use, embeddable, cross-platform interpreted
 scripting language.  This package contains the man pages for Tcl commands.

Package: tcl8.4-dev
Section: devel
Priority: optional
Architecture: any
Depends: tcl8.4 (= ${binary:Version}), ${misc:Depends}
Suggests: tcl8.4-doc
Description: Tcl (the Tool Command Language) v8.4 - development files
 Tcl is a powerful, easy-to-use, embeddable, cross-platform interpreted
 scripting language.  This package contains the headers and libraries
 needed to embed or extend Tcl.

=== debian/rules ===
#!/usr/bin/make -f

v = 8.4
DIR = $(shell pwd)/debian/tmp

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
export LDFLAGS

ifeq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
# See bug #446335
CFLAGS += -fno-unit-at-a-time
endif

%:
	dh $@

override_dh_auto_configure:
	# So so ugly but it works...
	touch generic/tclStubInit.c
	CC=$(DEB_HOST_GNU_TYPE)-gcc \
	ac_cv_func_strtod=yes \
	tcl_cv_strtod_buggy=1 \
	TCL_LIBRARY="/usr/share/tcltk/tcl$(v)" \
	TCL_PACKAGE_PATH="/usr/local/lib/tcltk /usr/local/share/tcltk /usr/lib/tcltk /usr/share/tcltk /usr/lib" \
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" \
	dh_auto_configure -Dunix -- \
			    --includedir=/usr/include/tcl$(v) \
			    --enable-shared \
			    --enable-threads \
			    --enable-man-symlinks \
			    --enable-man-compression=gzip

override_dh_auto_build:
	# Another ugly part
	touch generic/tclStubInit.c && \
	$(MAKE) -C unix
	# Build the static library
	cd unix && \
	  ar cr libtcl$(v).a *.o && \
	  ar d libtcl$(v).a tclAppInit.o && \
	  ranlib libtcl$(v).a

override_dh_auto_install:
	GZIP=-9 \
	$(MAKE) -C unix INSTALL_ROOT=$(DIR) \
			MAN_INSTALL_DIR=$(DIR)/usr/share/man \
			MANN_INSTALL_DIR=$(DIR)/usr/share/man/man3 \
		install
	# Fix up the libraries
	cp unix/libtcl$(v).a debian/tmp/usr/lib
	mv debian/tmp/usr/lib/libtcl$(v).so debian/tmp/usr/lib/libtcl$(v).so.0
	ln -sf libtcl$(v).so.0 debian/tmp/usr/lib/libtcl$(v).so
	mkdir debian/tmp/usr/lib/tcl$(v)
	mv debian/tmp/usr/lib/*.sh debian/tmp/usr/lib/tcl$(v)
	mkdir debian/tmp/usr/share/aclocal
	cp unix/tcl.m4 debian/tmp/usr/share/aclocal/tcl$(v).m4
	rm -f debian/tmp/usr/share/tcltk/tcl$(v)/ldAix
	# Fix up the include files
	install -d debian/tmp/usr/include/tcl$(v)/tcl-private/generic
	cp generic/*.h debian/tmp/usr/include/tcl$(v)/tcl-private/generic
	install -d debian/tmp/usr/include/tcl$(v)/tcl-private/unix
	cp unix/*.h debian/tmp/usr/include/tcl$(v)/tcl-private/unix
	install -d debian/tmp/usr/include/tcl$(v)/tcl-private/compat
	cp compat/*.h debian/tmp/usr/include/tcl$(v)/tcl-private/compat
	# Fix up the manpages
	cd debian/tmp/usr/share/man/man1 && \
	  zcat tclsh.1.gz | sed -e 's/(n)/(3tcl)/g' | gzip -9 > tclsh$(v).1.gz && \
	  rm tclsh.1.gz
	cd debian/tmp/usr/share/man/man3 && \
	  for f in *.[3n].gz ; do \
	     f2=$$(echo $$f | sed -e 's/\.[3n]/.3tcl/') ; \
	     if [ -L $$f ]; then \
		l=$$(readlink -n $$f |sed -e 's/\.[3n]/.3tcl/') ; \
		rm $$f ; \
		ln -sf $$l $$f2 ; \
	     else \
		zcat $$f | sed -e 's/^\.TH \([^ ]\+\|"[^"]\+"\) [3n]/.TH \1 3tcl/' \
			       -e 's/\(Tk_[0-9A-Za-z]*\)(3)/\1(3tk)/g' \
			       -e 's/\([A-Z][0-9A-Za-z_]*\)(3)/\1(3tcl)/g' \
			       -e 's/send(n)/send(3tk)/g' \
			       -e 's/text(n)/text(3tk)/g' \
			       -e 's/tk(n)/tk(3tk)/g' \
			       -e 's/winfo(n)/winfo(3tk)/g' \
			       -e 's/(n)/(3tcl)/g' \
			 | gzip -9 >$$f2 ; \
		rm $$f ; \
	     fi ; \
	  done

override_dh_makeshlibs:
	dh_makeshlibs -V 'tcl$(v) (>= 8.4.16)' -XTcltest

override_dh_shlibdeps:
	dh_shlibdeps -ldebian/tcl$(v)/usr/lib

get-orig-source:
	wget -O tcl8.4_8.4.19.orig.tar.gz \
	     http://prdownloads.sourceforge.net/tcl/tcl8.4.19-src.tar.gz

.PHONY: override_dh_auto_configure override_dh_auto_install override_dh_makeshlibs override_dh_shlibdeps get-orig-source

## tcl8.4 8.4.20

=== macosx/Makefile ===
--- 
+++ 
@@ -8,8 +8,6 @@
 #
 # See the file "license.terms" for information on usage and redistribution of
 # this file, and for a DISCLAIMER OF ALL WARRANTIES.
-#
-# RCS: @(#) $Id: Makefile,v 1.5.2.18 2007/09/13 15:28:17 das Exp $
 #
 ########################################################################################################

=== debian/changelog ===
tcl8.4 (8.4.20-8) unstable; urgency=low

  * Replaced calling ldconfig in postinst/postrm scripts by a trigger
    (closes: #811122).

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 16 Jan 2016 12:43:22 +0300

tcl8.4 (8.4.20-7) unstable; urgency=low

  * Upload into unstable.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 08 Mar 2014 09:18:51 +0400

tcl8.4 (8.4.20-6) experimental; urgency=low

  * Restored tcl8.4.prerm script which removes alternative for
    /usr/bin/tclsh8.4.
  * Bumped standards version to 3.9.5.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 10 Jan 2014 13:08:29 +0400

tcl8.4 (8.4.20-5) experimental; urgency=low

  * Renamed -dev package back to tcl8.4-dev after a discussion on debian-devel
    mailing list.
  * Fixed [:cntrl:] regexp character class by adding missing \u0000-\u001f
    characters range to it.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 25 Sep 2013 20:55:31 +0400

tcl8.4 (8.4.20-4) experimental; urgency=low

  * Removed unnecessary patch for init.tcl.
  * Make libtcl8.4-dev depend on tcl8.4 for better backward compatibility.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 19 Aug 2013 21:21:54 +0400

tcl8.4 (8.4.20-3) experimental; urgency=low

  * Renamed tcl8.4-lib and tcl8.4-dev packages into libtcl8.4 and
    libtcl8.4-dev to match common practice for packaging interpreters for
    Debian.
  * Fixed multi-arch header for the libtcl8.4-dev package.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 31 Jul 2013 10:43:34 +0400

tcl8.4 (8.4.20-2) experimental; urgency=low

  * Bumped debhelper compatibility version to 9.
  * Added multi-arch support. This includes splitting out the tcl8.4-lib
    library package with libtcl8.4.so and tclConfig.sh moved into a
    multi-archified location.
  * Recreated /usr/lib/tcl8.4/tclConfig.sh for backward compatibility
    (intend to remove in the future).
  * Removed .0 suffix from the libtcl8.4.so library in order to remove
    unnecessary diversions from the upstream practice, provided the symlink
    for backward compatibility (intend to remove in the future).
  * Switched to calculating dependency on tcl8.4-lib via a symbols table.
  * Don't use the alternatives mechanism for selecting /usr/bin/tclsh. This
    package ships only /usr/bin/tclsh8.4. The tcltk-defaults package provides
    the necessary symlink. This also means that tcl8.4 does no longer provide
    the tclsh virtual package.
  * Moved the old changelogs to the tcl8.4-doc package to reduce size of the
    tcl8.4 one.
  * Fixed clean target in debian/rules.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 12 Jul 2013 16:36:49 +0400

tcl8.4 (8.4.20-1) unstable; urgency=low

  * New upstream release.
  * Refreshed patches.
  * Pass CC to compiler and set ac_cv variables, to allow cross builds
    (closes: #597708)
  * Don't compress manpages twice during build process.
  * Bumped standards version to 3.9.4.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 24 Jun 2013 21:15:52 +0400

=== debian/rules ===
#!/usr/bin/make -f

v = 8.4
DIR = $(shell pwd)/debian/tmp

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
export LDFLAGS

ifeq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
# See bug #446335
CFLAGS += -fno-unit-at-a-time
endif

%:
	dh $@

override_dh_auto_clean:
	[ ! -f unix/Makefile ] || $(MAKE) -C unix distclean

override_dh_auto_configure:
	# So so ugly but it works...
	touch generic/tclStubInit.c
	CC=$(DEB_HOST_GNU_TYPE)-gcc \
	ac_cv_func_strtod=yes \
	tcl_cv_strtod_buggy=1 \
	TCL_LIBRARY="/usr/share/tcltk/tcl$(v)" \
	TCL_PACKAGE_PATH="/usr/local/lib/tcltk /usr/local/share/tcltk /usr/lib/tcltk/$(DEB_HOST_MULTIARCH) /usr/lib/tcltk /usr/share/tcltk /usr/lib" \
	CFLAGS="$(CFLAGS)" \
	CPPFLAGS="$(CPPFLAGS)" \
	TCL_SHLIB_LD_EXTRAS="-Wl,-soname,\$${TCL_LIB_FILE}" \
	dh_auto_configure -Dunix -- \
			  --includedir=/usr/include/tcl$(v) \
			  --enable-shared \
			  --enable-threads \
			  --disable-rpath \
			  --enable-man-symlinks

override_dh_auto_build:
	# Another ugly part
	touch generic/tclStubInit.c && \
	$(MAKE) -C unix
	# Build the static library
	cd unix && \
	  ar cr libtcl$(v).a *.o && \
	  ar d libtcl$(v).a tclAppInit.o && \
	  ranlib libtcl$(v).a

override_dh_auto_install:
	$(MAKE) -C unix INSTALL_ROOT=$(DIR) \
			MAN_INSTALL_DIR=$(DIR)/usr/share/man \
			MANN_INSTALL_DIR=$(DIR)/usr/share/man/man3 \
		install
	# Fix up the libraries
	cp unix/libtcl$(v).a $(DIR)/usr/lib/$(DEB_HOST_MULTIARCH)
	install -d -m 755 $(DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/tcl$(v)
	mv $(DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/*.sh $(DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/tcl$(v)
	install -d -m 755 $(DIR)/usr/share/aclocal
	cp unix/tcl.m4 $(DIR)/usr/share/aclocal/tcl$(v).m4
	rm -f $(DIR)/usr/share/tcltk/tcl$(v)/ldAix
	# Fix up the include files
	install -d $(DIR)/usr/include/tcl$(v)/tcl-private/generic
	cp generic/*.h $(DIR)/usr/include/tcl$(v)/tcl-private/generic
	install -d $(DIR)/usr/include/tcl$(v)/tcl-private/unix
	cp unix/*.h $(DIR)/usr/include/tcl$(v)/tcl-private/unix
	install -d $(DIR)/usr/include/tcl$(v)/tcl-private/compat
	cp compat/*.h $(DIR)/usr/include/tcl$(v)/tcl-private/compat
	#
	# Temporary HACK until all reverse dependencies will be rebuilt
	ln -sf libtcl$(v).so $(DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libtcl$(v).so.0
	#
	# Fix up the manpages
	cd $(DIR)/usr/share/man/man1 && \
	  sed -e 's/(n)/(3tcl)/g' tclsh.1 > tclsh$(v).1 && rm tclsh.1
	cd $(DIR)/usr/share/man/man3 && \
	  for f in *.[3n] ; do \
	     f2=$$(echo $$f | sed -e 's/\.[3n]/.3tcl/') ; \
	     if [ -L $$f ]; then \
		l=$$(readlink -n $$f |sed -e 's/\.[3n]/.3tcl/') ; \
		rm $$f ; \
		ln -sf $$l $$f2 ; \
	     else \
		sed -e 's/^\.TH \([^ ]\+\|"[^"]\+"\) [3n]/.TH \1 3tcl/' \
		    -e 's/\(Tk_[0-9A-Za-z]*\)(3)/\1(3tk)/g' \
		    -e 's/\([A-Z][0-9A-Za-z_]*\)(3)/\1(3tcl)/g' \
		    -e 's/send(n)/send(3tk)/g' \
		    -e 's/text(n)/text(3tk)/g' \
		    -e 's/tk(n)/tk(3tk)/g' \
		    -e 's/winfo(n)/winfo(3tk)/g' \
		    -e 's/(n)/(3tcl)/g' \
		    $$f >$$f2 ; \
		rm $$f ; \
	     fi ; \
	  done

override_dh_makeshlibs:
	dh_makeshlibs -a -Xtcltest
	echo 'activate-noawait ldconfig' >>debian/libtcl$(v).triggers

override_dh_shlibdeps:
	dh_shlibdeps -a -ldebian/libtcl$(v)/usr/lib/$(DEB_HOST_MULTIARCH)

get-orig-source:
	wget -O tcl$(v)_$(v).20.orig.tar.gz \
	     http://prdownloads.sourceforge.net/tcl/tcl$(v).20-src.tar.gz

.PHONY: override_dh_auto_clean override_dh_auto_configure override_dh_auto_install \
	override_dh_makeshlibs override_dh_shlibdeps get-orig-source

=== debian/watch ===
# Watch control file for uscan

# Compulsory line, this is a version 3 file
version=3

http://sf.net/tcl/tcl(8\.4\.[\d.]*)(?:-src)?.tar.gz
